<template>
  <authenticated-vue>
    <div class="w-100 bg-white shadow-lg p-5" id="card">
      <form @submit.prevent="submit">
        <header class="text-gray-600 py-3 pb-5 flex justify-between">
          <h3 class="text-xl">
            {{
              product && product.name
                ? "อัพเดทข้อมูลผลิตภัณฑ์"
                : "เพิ่มข้อมูลผลิตภัณฑ์"
            }}
          </h3>
          <button
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-400
              to-green-300
              rounded-md
              text-white
              shadow-md
            "
          >
            {{ product && product.name ? "อัพเดท" : "เพิ่ม" }}
          </button>
        </header>
        <div id="content">
          <div class="grid grid-cols-1 lg:grid-cols-3 md:grid-cols-2 gap-5">
            <div class="grid col-span-full md:grid-cols-3">
              <div>
                <span>ภาพหลัก</span>
                <el-upload
                  list-type="picture-card"
                  :action="route('upload')"
                  :on-success="handleUploadMainSuccess"
                  :before-upload="beforeUpload"
                  :on-remove="handleRemoveMainSuccess"
                  :file-list="form.main_filename"
                  :limit="1"
                >
                  <i class="el-icon-plus"></i>
                </el-upload>
                <small class="text-red-500 font-bold">{{
                  errors?.main_filename
                }}</small>
              </div>
              <div class="md:col-span-2">
                <span>ภาพประกอบ</span>
                <el-upload
                  list-type="picture-card"
                  :action="route('upload')"
                  :on-success="handleUploadSuccess"
                  :before-upload="beforeUpload"
                  :on-remove="handleRemoveSuccess"
                  :file-list="form.filenames"
                  :limit="6"
                >
                  <i class="el-icon-plus"></i>
                </el-upload>

                <small class="text-red-500 font-bold">{{
                  errors?.filenames
                }}</small>
              </div>
            </div>
            <div class="grid col-span-full">
              <label for="name"
                >ชื่อผลิตภัณฑ์ <small class="text-red-500">*</small>
              </label>
              <input
                type="text"
                class="
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300
                "
                v-model="form.name"
                placeholder="ชื่อผลิตภัณฑ์"
              />
              <small class="text-red-500 font-bold">{{ errors?.name }}</small>
            </div>
            <div class="grid col-span-full">
              <label for="name"
                >รายละเอียดผลิตภัณฑ์ <small class="text-red-500">*</small>
              </label>
              <textarea
                type="text"
                class="
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300
                "
                v-model="form.detail"
                placeholder="รายละเอียดผลิตภัณฑ์"
              ></textarea>
              <small class="text-red-500 font-bold">{{ errors?.name }}</small>
            </div>
            <div class="grid col-span-full">
              <label for="name"
                >โครงการ <small class="text-red-500">*</small>
              </label>
              <el-select
                v-model="form.project_id"
                filterable
                placeholder="จากโครงการ"
              >
                <el-option
                  v-for="item in projects"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                >
                  <div class="d-flex justify-between">
                    <span>{{ item.name }} </span>
                  </div>
                </el-option>
              </el-select>
              <small class="text-red-500 font-bold">{{
                errors?.project_id
              }}</small>
            </div>
          </div>
        </div>
        <footer class="text-gray-600 py-3 pt-5 flex justify-between">
          <button
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-400
              to-green-300
              rounded-md
              text-white
              shadow-md
            "
          >
            {{ product && product.name ? "อัพเดท" : "เพิ่ม" }}
          </button>
        </footer>
      </form>
    </div>
  </authenticated-vue>
</template>

<script>
import AuthenticatedVue from "@/Layouts/Authenticated.vue";
import { onMounted, ref, toRefs } from "vue";
import { Inertia } from "@inertiajs/inertia";
import { Toast } from "../Project/index.vue";
import Swal from "sweetalert2";

export default {
  components: {
    AuthenticatedVue,
  },
  props: {
    errors: Object,
    product: Object,
    projects: Array,
  },
  setup(props) {
    const { product } = toRefs(props);
    const dialogVisible = ref(false);
    const form = ref({
      main_filename: [],
      filenames: [],
      name: product.value?.name || null,
      project_id: product.value?.project_id || null,
      detail: product.value?.detail || null,
    });
    onMounted(() => {
      if (product.value) {
        product.value.filenames.forEach((file) => {
          form.value.filenames.push({
            name: file.filename,
            url: `/storage/uploads/${file.filename}`,
          });
        });
        form.value.main_filename.push({
          name: product.value?.main_filename,
          url: `/storage/uploads/${product.value?.main_filename}`,
        });
      }
    });
    const submit = () => {
      if (product.value) {
        Inertia.put(
          route("admin.products.update", { product: product.value.id }),
          { ...form.value },
          {
            onSuccess: () => {
              Inertia.get(route("admin.products.index"));
              Toast.fire({
                icon: "success",
                title: "อัพเดทข้อมูลผลิตภัณฑ์สำเร็จ ",
              });
            },
          }
        );
      } else {
        Inertia.post(
          route("admin.products.store"),
          { ...form.value },
          {
            onSuccess: () => {
              Inertia.get(route("admin.products.index"));
              Toast.fire({
                icon: "success",
                title: "เพิ่มข้อมูลผลิตภัณฑ์สำเร็จ ",
              });
            },
          }
        );
      }
    };

    const handleUploadSuccess = (res) => {
      const { status, file_name, msg } = res;
      if (status == 1) {
        form.value.filenames.push({
          name: file_name,
          url: `/storage/uploads/${file_name}`,
        });
      } else {
        Swal.fire({
          icon: "error",
          title: "Oops...",
          text: `${msg}`,
        });
      }
    };
    const beforeUpload = (file) => {
      //   const isPDF =
      //     file.type === "application/pdf" || file.type === "application/msword";
      console.log(file.type);
      const isLt3M = file.size / 1024 / 1024 < 3;
      //   if (!isPDF) {
      //     Swal.fire({
      //       icon: "error",
      //       title: "Oops...",
      //       text: `กรุณาเลือกไฟล์ให้ถูกต้อง`,
      //     });
      //   }
      if (!isLt3M) {
        Swal.fire({
          icon: "error",
          title: "Oops...",
          text: `ไฟล์มีขนาดใหญ่เกินไป`,
        });
      }
      return true;
    };
    const handleRemoveSuccess = (file) => {
      form.value.filenames = form.value.filenames.filter(
        (f) => f.name != file.name
      );
      console.log(form.value.filenames);
    };
    const handleUploadMainSuccess = (res) => {
      const { status, file_name, msg } = res;
      if (status == 1) {
        form.value.main_filename.push({
          name: file_name,
          url: `/storage/uploads/${file_name}`,
        });
      } else {
        Swal.fire({
          icon: "error",
          title: "Oops...",
          text: `${msg}`,
        });
      }
    };
    const handleRemoveMainSuccess = (file) => {
      form.value.main_filename = form.value.main_filename.filter(
        (f) => f.name != file.name
      );
      console.log(form.value.main_filename);
    };
    return {
      handleRemoveMainSuccess,
      handleUploadMainSuccess,
      handleUploadSuccess,
      beforeUpload,
      handleRemoveSuccess,
      dialogVisible,
      submit,
      form,
    };
  },
};
</script>

<style>
.el-date-editor--daterange.el-input,
.el-date-editor--daterange.el-input__inner,
.el-date-editor--timerange.el-input,
.el-date-editor--timerange.el-input__inner {
  width: 100%;
}
.el-date-editor.el-input,
.el-date-editor.el-input__inner {
  width: 100%;
}
</style>
